(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/forms')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common', '@angular/forms'], factory) :
	(factory((global['ng4-graph'] = {}),global.core,global.common,global.forms));
}(this, (function (exports,core,common,forms) { 'use strict';

var GraphComponent = (function () {
    function GraphComponent() {
        this.freqVal = 186;
        this.qVal = 0.48906580683982775;
        this.gainVal = 0.7199000039999994;
        window.self = {
            peaks: [[20, 1, 0], [20, 0.20222840258882313, -3.246930424000002], [186, 0.48906580683982775, 0.7199000039999994], [899, 0.1919914322977212, -0.29143898000000235], [22050, 0.2909137653414761, 1.6029143879999985]],
            w: 800,
            h: 600,
            y: 20,
            x: 30,
            ctx: null,
            canvas: null,
            RATE: 48E3,
            bands: 5,
            tn: 0,
            pressed: !1,
            dragging: !1,
            touchRadius: 32,
            mode: 2,
            cachedBg: null,
            elements: [],
            colors: ["#2D5EAA", "#2c8f29", "#b23535", "#752E99", "#C7AB35"],
            color: { "bg": "#16181C", "botBG": "#242424", "buttonsBG": "#919497", "tabStroke": "#535457", "masterLabel": "#ECCA12", "stripChLabel": "#C4C4C4", "labelText": "#F9F9F9", "labelTextSel": "#F9F9F9", "eqLabel": "#EEEEEE", "tabText": "#C8C9C9", "tabTextSel": "#f9f9f9", "vuBg": "#5E6168", "ledText": "#00ffff", "mLedText": "#E7E840", "eqBg": "#18191D", "eqBg2": "#18191D", "graphMarks": "#8D8E90", "yellow": "#BCA633", "red": "#A83B3B", "blue": "#3576B1", "brown": "#B28741", "green": "#47AF46", "purple": "#8835b1", "orange": "#b27635", "gray": "#B0AFAF", "black": "#060606", "sub": "#ba5d81", "modal": "#32ABBE", "media": "#A8184B", "white": "#f9f9f9", "presetBg": "#232627", "shadow": "#444", "maxx": "#AB9A89", "tvPhantom": "#3577b1", "tvInvert": "#b37936", "tvMute": "#b53636", "tvMuteMG": "#e55", "tvMuteUn": "#82C9DE", "tvSolo": "#c3a72d", "tvGray": "#555", "tvClearSolo": "#ccaf2f", "tvMuteALL": "#ba3838", "tvMuteFX": "#387dba", "tvInvertOff": "#4D4D5D", "tvPhantomOff": "#4D4D5D", "tvMuteOff": "#807B7B", "tvSoloOff": "#80807B", "EQ": "#A83B3B", "DYN": "#47AF46", "FX": "#3576B1", "AUX": "#BCA633", "MATRIX": "#b27635", "LINEIN": "#BC2D1B", "DIGI": "#bbb", "INPUT": "#c4673a", "vuPeak": "#b4b", "grad1": {}, "grad2": {}, "grad3": {}, "grad4": {}, "grad5": {}, "grad6": {}, "gradMBL": {}, "panGrad": {}, "mPanGrad": {}, "gradTVInd": null, "longClickMark": "rgba(100,100,100,0.5)", "me": "#FF9900", "GATE": "#6D9F36", "USB": "#C35353", "LOCAL": "#D08561", "SD": "#BCA633", "afsFixed": "#3333bb", "afsLive": "#DBD23C", "afsGraphPeakFixed": "rgba(51,51,187,0.6)", "afsGraphPeakLive": "rgba(219,210,60,0.6)", "tvvuGrad": {}, "tvvuGrad2": {}, "stripGrad": {}, "grpeak": {} },
            initEvents: this.initEvents,
            getValues: this.getValues,
            freqToX: this.freqToX,
            cachePaint: this.cachePaint,
            designHP: this.designHP,
            designPeak: this.designPeak,
            bound: this.bound,
            hexToRGBA: this.hexToRGBA,
            DeesserVtoFREQ: this.DeesserVtoFREQ,
            VtoFREQ: this.VtoFREQ,
            VtoEQGAIN20: this.VtoEQGAIN20,
            paint: this.paint,
            isIntersect: this.isIntersect,
            onMouseMove: this.onMouseMove,
            onMouseUp: this.onMouseUp,
            FREQtoX: this.FREQtoX,
            paintBackground: this.paintBackground,
            paintMarks: this.paintMarks,
            setShadow: this.setShadow
        };
    }
    /**
     * @return {?}
     */
    GraphComponent.prototype.ngAfterViewInit = function () {
        console.log('this.graphCanvas.nativeElement', this.graphCanvas.nativeElement);
        window.self.canvas = this.graphCanvas.nativeElement;
        window.self.ctx = window.self.canvas.getContext('2d');
        console.log('window.self.ctx', window.self.ctx);
        window.self.initEvents();
    };
    /**
     * @return {?}
     */
    GraphComponent.prototype.initEvents = function () {
        // window.self.canvas.addEventListener('mousedown', window.self.onMouseDown, !1);
        window.addEventListener('mousemove', window.self.onMouseMove, !1);
        window.addEventListener('mouseup', window.self.onMouseUp, !1);
        window.self.paintBackground();
        window.self.paint();
    };
    /**
     * @return {?}
     */
    GraphComponent.prototype.getValues = function () {
        console.log('getValues...');
    };
    /**
     * @param {?} a
     * @return {?}
     */
    GraphComponent.prototype.freqToX = function (a) {
        return (window.self.w - 1) * Math.log(a / 20) / Math.log(1102.5);
    };
    /**
     * @return {?}
     */
    GraphComponent.prototype.cachePaint = function () {
        console.log('cachePaint...');
        var /** @type {?} */ grd;
        window.self.cachedBg = document.createElement("canvas");
        var /** @type {?} */ a = window.self.cachedBg.getContext("2d");
        window.self.cachedBg.width = 2 * window.self.w, window.self.cachedBg.height = 2 * window.self.h, a.scale(2, 2);
        var /** @type {?} */ b = window.self.w, /** @type {?} */ c = window.self.h, /** @type {?} */ d = .5 * c / 20, /** @type {?} */ e = c / 2 | 0;
        a.fillStyle = "#0A0B0C";
        a.fillRect(0, 0, window.self.w, window.self.h);
        (a.fillStyle = grd, a.fillRect(0, 0, b, c));
        a.font = '12px open_sans_condensedbold';
        a.textAlign = "center";
        a.lineWidth = 1;
        a.fillStyle = "rgba(255,255,255,0.3)";
        a.fillRect(0, e - 1, b, 2);
        a.fillStyle = "rgba(255,255,255,0.1)";
        a.fillRect(0, e - 10 * d | 0, b, .5);
        a.fillRect(0, e + 10 * d | 0, b, .5);
        a.strokeStyle = "rgba(255,255,255,0.15)";
        a.lineWidth = .5;
        a.beginPath();
        a.moveTo(0, e - 1);
        a.lineTo(b, e - 1);
        a.fillStyle = window.self.color.labelText;
        for (b = 30; 100 >= b; b += 10)
            d = (window.self.freqToX(b) | 0) + .5, a.moveTo(d, 0), a.lineTo(d, c - 1);
        for (b = 100; 1E3 >= b; b += 100)
            d = (window.self.freqToX(b) | 0) + .5, a.moveTo(d, 0), a.lineTo(d, c - 1);
        for (b =
            1E3; 1E4 >= b; b += 1E3)
            d = (window.self.freqToX(b) | 0) + .5, a.moveTo(d, 0), a.lineTo(d, c - 1);
        a.stroke();
        var /** @type {?} */ egrad = window.self.ctx.createLinearGradient(0, 0, window.self.w, 0);
        egrad.addColorStop(0, window.self.colors[1]);
        egrad.addColorStop(.5, window.self.colors[2]);
        egrad.addColorStop(1, window.self.colors[3]);
    };
    /**
     * @param {?} a
     * @param {?} b
     * @param {?} c
     * @return {?}
     */
    GraphComponent.prototype.designHP = function (a, b, c) {
        console.log('designHP...');
        if (20.1 > b)
            return [1, 0, 0, 1, 0, 0];
        a = 2 * Math.PI * b / a;
        b = Math.sin(a);
        a = Math.cos(a);
        var /** @type {?} */ d = b / (2 * c);
        b = 1 + d;
        c = -(2 * a) / b;
        d = (1 - d) / b;
        b = Math.pow(10, 0) / b;
        return [.5 * (1 + a) * b, -(1 + a) * b, .5 * (1 + a) * b, 1, c, d];
    };
    /**
     * @param {?} a
     * @param {?} b
     * @param {?} c
     * @param {?} d
     * @return {?}
     */
    GraphComponent.prototype.designPeak = function (a, b, c, d) {
        console.log('designPeak...');
        if (-.001 <= d && .001 >= d)
            return [1, 0, 0, 1, 0, 0];
        d = Math.pow(10, d / 40);
        b = 2 * Math.PI * b / a;
        a = Math.cos(b);
        c = b * (2 * Math.PI - b) / (c * (4 * Math.PI - b));
        var /** @type {?} */ e = 1 + c / d;
        b = -(2 * a) / e;
        var /** @type {?} */ f = (1 - c / d) / e, /** @type {?} */ e = Math.pow(10, 0) / e;
        return [(1 + c * d) * e, -(2 * a) * e, (1 - c * d) * e, 1, b, f];
    };
    /**
     * @param {?} a
     * @param {?} b
     * @param {?} c
     * @return {?}
     */
    GraphComponent.prototype.bound = function (a, b, c) {
        console.log('bound...');
        return a < b ? b : a > c ? c : a;
    };
    /**
     * @param {?} a
     * @param {?} b
     * @return {?}
     */
    GraphComponent.prototype.hexToRGBA = function (a, b) {
        console.log('hexToRGBA...');
        if (!a || "r" == a[0])
            return a;
        a = a.replace("#", "");
        var /** @type {?} */ c = window.self.bound(parseInt(a.substring(0, 2), 16), 0, 255), /** @type {?} */ d = window.self.bound(parseInt(a.substring(2, 4), 16), 0, 255), /** @type {?} */ e = window.self.bound(parseInt(a.substring(4, 6), 16), 0, 255), /** @type {?} */ f = window.self.bound(b, 0, 1);
        return "rgba(" + c + "," + d + "," + e + "," + f + ")";
    };
    /**
     * @param {?} a
     * @return {?}
     */
    GraphComponent.prototype.DeesserVtoFREQ = function (a) {
        return 2E3 * Math.pow(7.5, a);
    };
    /**
     * @param {?} a
     * @return {?}
     */
    GraphComponent.prototype.VtoFREQ = function (a) {
        return Math.round(20 * Math.pow(1102.5, a));
    };
    /**
     * @param {?} a
     * @return {?}
     */
    GraphComponent.prototype.VtoEQGAIN20 = function (a) {
        return 40 * a - 20;
    };
    /**
     * @return {?}
     */
    GraphComponent.prototype.paint = function () {
        window.self.elements = [];
        window.self.cachePaint();
        window.self.ctx.drawImage(window.self.cachedBg, 0, 0, window.self.w, window.self.h);
        window.self.ctx.fillStyle = "rgba(255,255,255,0.04)";
        window.self.ctx.fillRect(0, 0, window.self.w, window.self.h);
        var /** @type {?} */ a = window.self.w, /** @type {?} */ b = window.self.h, /** @type {?} */ c = window.self.peaks, /** @type {?} */ d = .5 * b / 20, /** @type {?} */ e = b / 2 | 0;
        window.self.freqPlot = Array(a);
        window.self.freqPlot2 = Array(a);
        window.self.xToFreq = Array(a);
        window.self.xToAngular = Array(a);
        window.self.xCos1 = Array(a);
        window.self.xCos2 = Array(a);
        for (var /** @type {?} */ f_1 = 0; f_1 < a; f_1++) {
            var /** @type {?} */ b_1 = 20 * Math.pow(1102.5, 1 * f_1 / a), /** @type {?} */ g_1 = 2 * b_1 * Math.PI / window.self.RATE, /** @type {?} */ h_1 = Math.cos(g_1), /** @type {?} */ k_1 = Math.cos(2 * g_1);
            window.self.xToFreq[f_1] = b_1;
            window.self.xToAngular[f_1] = g_1;
            window.self.xCos1[f_1] = h_1;
            window.self.xCos2[f_1] = k_1;
        }
        var /** @type {?} */ g;
        var /** @type {?} */ f;
        var /** @type {?} */ l;
        var /** @type {?} */ m;
        var /** @type {?} */ n;
        var /** @type {?} */ p;
        var /** @type {?} */ q;
        var /** @type {?} */ k;
        var /** @type {?} */ h;
        for (b = 0; b < a; b++)
            window.self.freqPlot[b] = 0, window.self.freqPlot2[b] = 0;
        for (b = 0; b < window.self.bands; b++)
            for (g = null, g = 0 == b ? window.self.designHP(window.self.RATE, window.self.bound(c[b][0], 20, 1E3), Math.sqrt(2) / 2) : window.self.designPeak(window.self.RATE, c[b][0], c[b][1], c[b][2]), f = g[3], l = g[0], n = g[1], m = g[2], p = g[4], h = g[5],
                g = l * l + n * n + m * m, n = 2 * n * (l + m), l = 2 * l * m, m = f * f + p * p + h * h, p = 2 * p * (f + h), q = 2 * f * h, f = 0; f < a; f++)
                h = window.self.xCos1[f], k = window.self.xCos2[f], h = 4.3429448190325175 * Math.log((g + n * h + l * k) / (m + p * h + q * k)), window.self.freqPlot[f] += h, b == window.self.mode && (window.self.freqPlot2[f] += h);
        window.self.ctx.lineWidth = 2;
        window.self.ctx.lineJoin = "round";
        window.self.showCurrentCurve = true;
        if (window.self.showCurrentCurve) {
            window.self.ctx.beginPath();
            for (f = 0; f < a; f++)
                if (!(1 == (f & 1) && f < a - 1) || window.self.freqPlot2[f] > window.self.freqPlot2[f - 1] && window.self.freqPlot2[f] > window.self.freqPlot2[f + 1] || window.self.freqPlot2[f] < window.self.freqPlot2[f - 1] && window.self.freqPlot2[f] < window.self.freqPlot2[f +
                    1])
                    g = e - d * window.self.freqPlot2[f], 0 == f && window.self.ctx.moveTo(f, g), window.self.ctx.lineTo(f, g);
            window.self.ctx.lineWidth = 1;
            window.self.ctx.strokeStyle = window.self.colors[window.self.mode];
            window.self.ctx.fillStyle = window.self.hexToRGBA(window.self.colors[window.self.mode], .1);
            window.self.ctx.stroke();
            window.self.ctx.lineTo(a, e);
            window.self.ctx.lineTo(0, e);
            window.self.ctx.closePath();
            window.self.ctx.fill();
        }
        window.self.ctx.beginPath();
        window.self.ctx.fillStyle = "rgba(255,255,255,0.12)";
        window.self.ctx.strokeStyle = "#ffffff";
        window.self.ctx.lineWidth = 2;
        for (f = 0; f < a; f++)
            if (!(1 == (f & 1) && f < a - 1) || window.self.freqPlot[f] > window.self.freqPlot[f - 1] && window.self.freqPlot[f] > window.self.freqPlot[f + 1] || window.self.freqPlot[f] < window.self.freqPlot[f - 1] &&
                window.self.freqPlot[f] < window.self.freqPlot[f + 1])
                g = e - d * window.self.freqPlot[f], 0 == f && window.self.ctx.moveTo(f, g), window.self.ctx.lineTo(f, g);
        window.self.ctx.stroke();
        window.self.ctx.lineTo(a, e);
        window.self.ctx.lineTo(0, e);
        window.self.ctx.closePath();
        window.self.ctx.fill();
        window.self.ctx.textAlign = "center";
        window.self.easy = window.self.bypass = false;
        if (window.self.easy) {
            for (window.self.ctx.strokeStyle = "rgba(255,255,255,0.5)", window.self.ctx.font = "bold 15px open_sans_condensedbold", l = ["B", "M", "T"], a = [1, 2, 3], n = 0; n < l.length; n++)
                b = a[n], f = window.self.freqToX(c[b][0]), 1 == b && (f += window.self.w / 6), 3 == b && (f -= window.self.w / 6), g = e - c[b][2] * d, window.self.ctx.lineWidth = "3", window.self.bypass && 0 != b ? (window.self.ctx.fillStyle = "rgba(255,255,255,0.4)", window.self.ctx.strokeStyle =
                    "rgba(255,255,255,0.3)") : (window.self.ctx.fillStyle = window.self.colors[b], window.self.ctx.strokeStyle = window.self.colors[b]), window.self.ctx.globalAlpha = .9, window.self.ctx.beginPath(), window.self.ctx.arc(f, g, 16, 0, 2 * Math.PI), window.self.ctx.fill(), window.self.tx.globalAlpha = 1, window.self.ctx.beginPath(), window.self.ctx.arc(f, g, window.self.touchRadius, 0, 2 * Math.PI), window.self.ctx.globalAlpha = .38, window.self.ctx.fill(), window.self.ctx.globalAlpha = 1, window.self.mode == b && window.self.ctx.stroke(), window.self.ctx.fillStyle = "#060606", window.self.ctx.fillText(l[n], f - (0 == b ? 1 : 0) + 1, g + 5 + 1), window.self.ctx.fillStyle = "#F0F0F0", window.self.ctx.fillText(l[n], f - (0 == b ? 1 : 0), g + 5);
        }
        else {
            for (window.self.ctx.strokeStyle = "rgba(255,255,255,0.5)", window.self.ctx.font = "bold 14px open_sans_condensedbold", l = ["HPF", "1", "2", "3", "4"], b = 0; b < window.self.bands; b++) {
                if (f = window.self.freqToX(c[b][0]), g = e - c[b][2] * d, window.self.ctx.lineWidth = "3", window.self.bypass && 0 != b) {
                    window.self.ctx.fillStyle = "rgba(255,255,255,0.4)";
                    window.self.ctx.strokeStyle = "rgba(255,255,255,0.3)";
                }
                else {
                    window.self.ctx.fillStyle = window.self.colors[b];
                    window.self.ctx.strokeStyle = window.self.colors[b];
                    window.self.ctx.globalAlpha = .9;
                    window.self.ctx.beginPath();
                    window.self.ctx.arc(f, g, 13, 0, 2 * Math.PI);
                    window.self.ctx.fill();
                    window.self.ctx.globalAlpha = 1;
                    window.self.ctx.beginPath();
                    window.self.ctx.arc(f, g, window.self.touchRadius, 0, 2 * Math.PI);
                    window.self.ctx.globalAlpha = .38;
                    window.self.ctx.fill();
                    window.self.ctx.globalAlpha = 1;
                    window.self.mode == b && window.self.ctx.stroke();
                    window.self.ctx.fillStyle = "#060606";
                    window.self.ctx.fillText(l[b], f + 1, g + 6);
                    window.self.ctx.fillStyle = "#F0F0F0";
                    window.self.ctx.fillText(l[b], f, g + 5);
                    window.self.elements.push({ name: l[b], x: f + 24, y: g + 65, radius: window.self.touchRadius });
                }
            }
            console.log('elements', window.self.elements);
        }
        window.self.ctx.lineWidth = 1;
        window.self.ctx.strokeStyle = "#222";
        window.self.ctx.strokeRect(.5, .5, window.self.w - 1, window.self.h - 1);
        window.self.showPreset = true;
        window.self.showPreset && (window.self.ctx.textAlign = "left", window.self.ctx.fillStyle == 0 ? "#444" : window.self.color.red, window.self.ctx.font = "18px open_sans_condensedbold", window.self.ctx.fillText("", 4, 18));
        $("freqSlider").val(String(window.self.peaks[window.self.mode]).split(",")[0]);
        $("qSlider").val(String(window.self.peaks[window.self.mode]).split(",")[1]);
        $("gainSlider").val(String(window.self.peaks[window.self.mode]).split(",")[2]);
        window.self.paintMarks();
    };
    /**
     * @param {?} point
     * @param {?} element
     * @return {?}
     */
    GraphComponent.prototype.isIntersect = function (point, element) {
        return Math.sqrt(Math.pow((point.x - element.x), 2) + Math.pow((point.y - element.y), 2)) < element.radius;
    };
    /**
     * @param {?} e
     * @return {?}
     */
    GraphComponent.prototype.onMouseDown = function (e) {
        console.log("onMouseDown...");
        var /** @type {?} */ mousePoint = {
            x: e.clientX,
            y: e.clientY
        };
        window.self.elements.forEach(function (element) {
            if (window.self.isIntersect(mousePoint, element)) {
                console.log("Click on element...");
                window.self.mode = element.name === "HPF" ? 0 : element.name;
                $("freqSlider").val(String(window.self.peaks[window.self.mode]).split(",")[0]);
                $("qSlider").val(String(window.self.peaks[window.self.mode]).split(",")[1]);
                $("gainSlider").val(String(window.self.peaks[window.self.mode]).split(",")[2]);
                window.self.dragging = !0;
                window.self.paint();
            }
        });
    };
    /**
     * @param {?} e
     * @return {?}
     */
    GraphComponent.prototype.onMouseMove = function (e) {
        if (window.self.dragging) {
            console.log("onMouseMove...");
            var /** @type {?} */ data = [];
            data = String(window.self.peaks[window.self.mode]).split(",");
            var /** @type {?} */ a = window.self.bound(e.clientX - 24, 0, window.self.w);
            var /** @type {?} */ b = window.self.bound(e.clientY - 80, 0, window.self.h);
            if (window.self.mode > 0) {
                data[0] = a / window.self.w;
                data[2] = 1 - b / window.self.h;
                window.self.peaks[window.self.mode] = [window.self.VtoFREQ(data[0]), Number(data[1]), window.self.VtoEQGAIN20(data[2])];
            }
            else {
                data[0] = window.self.bound(a / window.self.w, 0, .5588);
                window.self.peaks[window.self.mode] = [window.self.VtoFREQ(data[0]), Number(data[1]), Number(data[2])];
            }
            window.self.paint();
        }
    };
    /**
     * @param {?} e
     * @return {?}
     */
    GraphComponent.prototype.onMouseUp = function (e) {
        console.log("onMouseUp...");
        window.self.dragging = !1;
    };
    /**
     * @return {?}
     */
    GraphComponent.prototype.onSliderInputEvent = function () {
        window.self.peaks[window.self.mode] = [this.freqVal, this.qVal, this.gainVal];
        window.self.paint();
    };
    /**
     * @param {?} a
     * @param {?} b
     * @return {?}
     */
    GraphComponent.prototype.FREQtoX = function (a, b) {
        return (b - 1) * Math.log(a / 20) / Math.log(1102.5);
    };
    /**
     * @return {?}
     */
    GraphComponent.prototype.paintBackground = function () {
        window.self.ctx.fillRect(0, window.self.y, window.self.w + window.self.x + 35, window.self.h + 40);
        window.self.ctx.translate(window.self.x, window.self.y);
    };
    /**
     * @return {?}
     */
    GraphComponent.prototype.paintMarks = function () {
        window.self.ctx.textAlign = "center";
        var /** @type {?} */ a = window.self.h, /** @type {?} */ b = window.self.w, /** @type {?} */ c = a / 4, /** @type {?} */ d = a / 2 | 0, /** @type {?} */ e = [50, 100, 200, 500, 1E3,
            2E3, 5E3, 1E4
        ], /** @type {?} */ f = "50 100 200 500 1k 2k 5k 10k".split(" ");
        // Bottom Bar
        window.self.ctx.font = 'bold 11px open_sans_condensedbold';
        window.self.ctx.fillStyle = "#101115";
        window.self.ctx.fillRect(0, window.self.h, window.self.w + 35, 40);
        window.self.ctx.fillStyle = window.self.color.graphMarks;
        window.self.ctx.textAlign = "left";
        window.self.ctx.fillText("20", 0, a + 15);
        window.self.ctx.fillText("22k", b - 20, a + 15);
        window.self.ctx.textAlign = "center";
        for (c = 0; c < e.length; c++)
            window.self.ctx.fillText(f[c], window.self.FREQtoX(e[c], b), a + 15);
        // Left Bar
        var /** @type {?} */ a = window.self.h, /** @type {?} */ b = window.self.w, /** @type {?} */ c = a / 4, /** @type {?} */ d = a / 2 | 0;
        window.self.ctx.fillStyle = "#101115";
        window.self.ctx.fillRect(-30, -20, 30, window.self.h + 60);
        window.self.ctx.textAlign = "center";
        window.self.ctx.font = 'bold 11px open_sans_condensedbold';
        window.self.ctx.save();
        window.self.ctx.translate(window.self.x, window.self.y);
        window.self.ctx.fillStyle = window.self.color.graphMarks;
        window.self.ctx.textAlign = "right";
        window.self.ctx.fillText("+20", -35, -10);
        window.self.ctx.fillText("+10", -35, c - 15);
        window.self.ctx.fillText("0", -35, d - 15);
        window.self.ctx.fillText("-10", -35, 3 * c - 15);
        window.self.ctx.fillText("-20", -35, a - 20);
        // Top Bar
        window.self.ctx.fillStyle = "#101115";
        window.self.ctx.fillRect(-30, -40, window.self.w + 35, 20);
        // Right Bar
        window.self.ctx.fillStyle = "#101115";
        window.self.ctx.fillRect(window.self.w - 30, -20, 35, window.self.h);
        window.self.ctx.restore();
    };
    /**
     * @param {?} a
     * @param {?} b
     * @param {?} c
     * @param {?} d
     * @return {?}
     */
    GraphComponent.prototype.setShadow = function (a, b, c, d) {
        CanvasRenderingContext2D.prototype.shadowColor = 'transparent';
    };
    return GraphComponent;
}());
GraphComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'graph-component',
                template: "<!-- <input id=\"freqSlider\" type=\"range\" min=\"20\" max=\"22050\" [(ngModel)]=\"freqVal\" step=\"0.01\" (input)=\"onSliderInputEvent()\" /> <input id=\"qSlider\" type=\"range\" min=\"0.05\" max=\"15\" [(ngModel)]=\"qVal\" step=\"0.01\" (input)=\"onSliderInputEvent()\" /> <input id=\"gainSlider\" type=\"range\" min=\"-20\" max=\"20\" [(ngModel)]=\"gainVal\" step=\"0.01\" (input)=\"onSliderInputEvent()\" /> --> <canvas #graphCanvas id=\"mixer\" width=\"850\" height=\"650\" (mousedown)=\"onMouseDown($event)\">Your browser does not support HTML5 Canvas.</canvas>",
                styles: ["html, body { position: relative; overflow-x: hidden; overflow-y: hidden; width: 100%; height: 100%; -webkit-user-select: none; -moz-user-select: none; -ms-user-select: none; user-select: none; -ms-touch-action: none; touch-action: none } canvas { display: block; }"]
            },] },
];
/**
 * @nocollapse
 */
GraphComponent.ctorParameters = function () { return []; };
GraphComponent.propDecorators = {
    'graphCanvas': [{ type: core.ViewChild, args: ['graphCanvas', { read: core.ElementRef },] },],
};

var GraphDirective = (function () {
    /**
     * @param {?} el
     */
    function GraphDirective(el) {
        this.el = el;
    }
    return GraphDirective;
}());
GraphDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[graphDirective]'
            },] },
];
/**
 * @nocollapse
 */
GraphDirective.ctorParameters = function () { return [
    { type: core.ElementRef, },
]; };

/**
 * Transforms any input value
 */
var GraphPipe = (function () {
    function GraphPipe() {
    }
    /**
     * @param {?} value
     * @param {?=} args
     * @return {?}
     */
    GraphPipe.prototype.transform = function (value, args) {
        if (args === void 0) { args = null; }
        return value;
    };
    return GraphPipe;
}());
GraphPipe.decorators = [
    { type: core.Pipe, args: [{
                name: 'graphPipe'
            },] },
    { type: core.Injectable },
];
/**
 * @nocollapse
 */
GraphPipe.ctorParameters = function () { return []; };

var GraphService = (function () {
    function GraphService() {
    }
    return GraphService;
}());
GraphService.decorators = [
    { type: core.Injectable },
];
/**
 * @nocollapse
 */
GraphService.ctorParameters = function () { return []; };

var Ng4GraphModule = (function () {
    function Ng4GraphModule() {
    }
    /**
     * @return {?}
     */
    Ng4GraphModule.forRoot = function () {
        return {
            ngModule: Ng4GraphModule,
            providers: []
        };
    };
    return Ng4GraphModule;
}());
Ng4GraphModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule,
                    forms.FormsModule
                ],
                declarations: [
                    GraphComponent
                ],
                exports: [
                    GraphComponent
                ]
            },] },
];
/**
 * @nocollapse
 */
Ng4GraphModule.ctorParameters = function () { return []; };

exports.Ng4GraphModule = Ng4GraphModule;
exports.GraphComponent = GraphComponent;
exports.GraphDirective = GraphDirective;
exports.GraphPipe = GraphPipe;
exports.GraphService = GraphService;

Object.defineProperty(exports, '__esModule', { value: true });

})));
